<?php
/*
* @author Baptiste ROUSSEL
* @version 1.0.3
* @license MPL 2.0
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. 
* If a copy of the MPL was not distributed with this file, You can obtain one at http://mozilla.org/MPL/2.0/.
*/
session_start();
if( !isSet($_SESSION['id']) ){
	exit();
}

if( empty($_POST['inventory']) ){
	exit();
}

include_once( '../config.inc.php' );

header('Cache-Control: no-cache, must-revalidate');
header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
header('Content-type: application/json');

$tmp = explode(',',$_POST['inventory']);
$inventory = array();
foreach($tmp as $id){
	if( isSet($inventory[$id]) ){
		$inventory[$id]['quantity']++;
	}
	else{
		$item = new Item($id);
		$inventory[$id] = array(
			'id' => $id,
			'name' => $item->name,
			'description' => $item->description,
			'category' => $item->category,
			'text' => sprintf( $lang['phrase']['item_name'], $item->name, $item->category ),
			'icon' => $item->icon,
			'quantity' => 1,
		);
		unset($item);
	}
}
foreach($inventory as $i => $item){
	$quantity = ( $item['quantity'] > 1 )? 'x' . $item['quantity'] : '';
	$inventory[$i]['tip'] = sprintf( $lang['phrase']['item_tooltip'], JS_protect( $item['name'] ), JS_protect( $quantity ), JS_protect( $item['description'] ) );
}
echo json_encode($inventory);

?>