<?php
/*
* @author Baptiste ROUSSEL
* @version 1.0.3
* @license MPL 2.0
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. 
* If a copy of the MPL was not distributed with this file, You can obtain one at http://mozilla.org/MPL/2.0/.
*/
session_start();

if( empty($_GET['s']) ){
	exit();
}

include_once( '../config.inc.php' );

header('Cache-Control: no-cache, must-revalidate');
header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
header('Content-type: application/json');

try{
	$db = Database::getDatabase();
	$res = $db->prepare('SELECT `iddata` FROM `' . TBL_D . '` WHERE `name` LIKE :name ORDER BY `name`');
	$res->bindValue(':name','%' . $_GET['s'] . '%',PDO::PARAM_STR);
	$res->execute();
	$response = array();
	if( $datas = $res->fetchAll() ){
		foreach($datas as $data){
			$d = new Data($data['iddata']);
			$response[] = array(
					'id' => $d->id,
					'name' => $d->name,
					'type' => $d->type->name,
					'classe' => $d->classe->name,
					'img' => $d->image
				);
		}
	}
	echo json_encode($response);
}catch(Exception $e){
	echo $e;
}