<?php

/**
* Configuration file
*
* @version 0.1
* @author Baptiste ROUSSEL
*/
// Configuration file
require_once( 'config/config.inc.php');
// Class
require_once( 'class/hash.class.php' );
require_once( 'class/database.class.php' );
require_once( 'class/dice.class.php' );
require_once( 'class/skill.class.php' );
require_once( 'class/ability.class.php' );
require_once( 'class/type.class.php' );
require_once( 'class/classe.class.php' );
require_once( 'class/item.class.php' );
require_once( 'class/data.class.php' );
// Database's connexion
new Database( $databaseDsn, $databaseLogin, $databasePassword, $databaseOptions );
// Import Lang file
$lang = parse_ini_file( $lang_path . $langFile . '.ini', true );
// Token
$token_validity   = 60 * 5; // 5 minutes
$connection_token = sha1(mt_rand() . 'token' . time());
// Const
define( 'NL', "\r\n" );
/*
* Protect a String before JS use
* @param (String)
* @return (String)
*/
function JS_protect( $string )
{
	return addslashes( str_replace( "\r\n", '', $string ) );
}
/*
* Unset securityKey and Database variables + set the connexion token
*/
function secureScope()
{
	global $securityKey, $token_validity, $connection_token;
	global $database, $databaseDsn, $databaseLogin, $databasePassword, $databaseOptions;
	unset( $securityKey );
	unset( $database, $databaseDsn, $databaseLogin, $databasePassword, $databaseOptions );
	$_SESSION['token'] = array($connection_token, time() + $token_validity);
}
/*
* Check if the content need to be hidden or not
* @param (bool) GM view only or not
* @return (bool) visible
*/
function isVisible($bool){
	if( $bool === true && empty($_SESSION['id']) )
		return false;
	return true;
}

/*
* Create a log action
* @param (String) Log action
* @return (bool)
*/
function actionLog($action){
	if( empty($action) || !is_string($action))
		return false;
	try{
		$db   = Database::getDatabase();
		$user = (isSet($_SESSION['id'])) ? $_SESSION['id'] : 0;
		if( $db != null )
			$db->query("INSERT into `" . TBL_GM_LOG . "`(`idgm_account`,`value`,`created`) VALUES(". $db->quote($user).",".$db->quote($action).",NOW())");
		else
			return false;
	}catch(Exception $e){
		return false;
	}
	return true;
}

/*
* Check if the account have the right to be here
* @param (String) Access' name
* @return (bool)
*/
function isAllowed($access){
	return (isSet($_SESSION['access'][$access]) && $_SESSION['access'][$access] === true);
}

?>