<?php
/*
* @author Baptiste ROUSSEL
* @version 1.0.3
* @license MPL 2.0
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. 
* If a copy of the MPL was not distributed with this file, You can obtain one at http://mozilla.org/MPL/2.0/.
*/
session_start();
require_once( 'config.inc.php' );
if( isSet($_GET['js']) ) // Detection of Javascript activation
	$_SESSION['js'] = ($_GET['js'] == 1) ? true : false;
try {
	//var_dump($_GET);
	if( isSet($_GET['cat'])){
		switch($_GET['cat']){
			case 'login':
				/***********************************************************
				*						LOGIN
				************************************************************/
				// Verify token
				if( isSet($_POST['token']) && $_POST['token'] == $_SESSION['token'][0] && time() <= $_SESSION['token'][1] ){
					if( isSet($_POST['username']) && isSet($_POST['password']) ){
						$db  = Database::getDatabase();
						$res = $db->prepare('SELECT `idgm_account`, `password` FROM `' . TBL_GM_ACT . '` WHERE `login` = :login');
						$res->bindValue(':login',$_POST['username']);
						$res->execute();
						if( $res->rowCount() == 1 ){
							$account = $res->fetch();
							if( Hash::check_password($account['password'], $_POST['password']) ){
								$_SESSION['id']     = $account['idgm_account'];
								$_SESSION['login']  = $_POST['username'];
								$res                = $db->query('SELECT `' . TBL_GM_ACC . '`.`idaccess`, `' . TBL_ACC . '`.`name`  FROM `' . TBL_ACC . '` INNER JOIN `' . TBL_GM_ACC . '` ON `' . TBL_ACC . '`.`idaccess` = `' . TBL_GM_ACC . '`.`idaccess` WHERE `' . TBL_GM_ACC . '`.`idgm_account` = ' . $db->quote($account['idgm_account']));
								$_SESSION['access'] = array();
								while($r = $res->fetch())
									$_SESSION['access'][$r['name']] = true;
								actionLog($lang['term']['panel_login']);
								header('Location: panel.php');
								exit();
							}
							else{
								header('Location: index.php?login=0&login_error=1');
								exit();
							}
						}
						else{
							header('Location: index.php?login=0&login_error=1');
							exit();
						}
					}
				}
				header('Location:index.php?login=0');
				exit();
			break;
			case 'logoff':
				/***********************************************************
				 *						LOGOFF
				 ************************************************************/
				unset($_SESSION['id'],$_SESSION['login']);
				session_unset();
				session_destroy();
				header('Location: index.php');
				exit();
			break;
			case 'sheet':
				/***********************************************************
				 *					DATA SHEET
				 ************************************************************/
				if( isSet($_GET['act']) ){
					if( $_GET['act'] == "next" && !empty($_GET['id']) ){
						// Search the next Data sheet
						$db  = Database::getDatabase();
						$res = $db->prepare('SELECT `iddata` AS `idnext` FROM `' . TBL_D . '` WHERE `iddata` > :id ORDER BY `iddata` ASC LIMIT 1');
						$res->bindValue(':id',$_GET['id'],PDO::PARAM_INT);
						$res->execute();
						if( $res->rowCount() == 1 ){
							$d          = $res->fetch();
							$_GET['id'] = $d['idnext'];
						}
						else
						{
							// Next not found, we select the first ID
							$res = $db->query('SELECT min(`iddata`) AS `idmin` FROM `' . TBL_D . '`');
							if( $res->rowCount() == 1 ){
								$d          = $res->fetch();
								$_GET['id'] = $d['idmin'];
							}
							else{
								header('Location: index.php');
								exit();
							}
						}

					}
					elseif( $_GET['act'] == "previous" && !empty($_GET['id']) ){
						// Search the previous Character sheet
						$db = Database::getDatabase();
						$res = $db->prepare('SELECT `iddata` AS `idprevious` FROM `' . TBL_D . '` WHERE `iddata` < :id ORDER BY `iddata` DESC LIMIT 1');
						$res->bindValue(':id',$_GET['id'],PDO::PARAM_INT);
						$res->execute();
						if( $res->rowCount() == 1 ){
							$d          = $res->fetch();
							$_GET['id'] = $d['idprevious'];
						}
						else
						{
							// Previous not found, we select the last ID
							$res = $db->query('SELECT max(`iddata`) AS `idmax` FROM `' . TBL_D . '`');
							if( $res->rowCount() == 1 ){
								$d          = $res->fetch();
								$_GET['id'] = $d['idmax'];
							}
							else{
								header('Location: index.php');
								exit();
							}
						}
					}
				}
				if( isSet($_GET['id']) && is_numeric($_GET['id']) && $_GET['id'] > 0 ){
					$data = new Data($_GET['id'],Data::FULL);
					$_SESSION['data_id'] = intval($_GET['id']);
					$page                = 'sheet';
				}
				elseif( !empty($_SESSION['data_id']) ){
					$data = new Data($_SESSION['data_id'],Data::FULL);
					$page = 'sheet';
				}
			break;
		}
	}

	// Is Login required ?
	if( isSet($_GET['login']) )
		$login_required = !(bool)$_GET['login'];

	if( empty($page) ){
		$db      = Database::getDatabase();
		$stats = array(
				'data' => 0,
				'item' => 0,
				'skill' => 0,
				'ability' => 0
			);
		$res     = $db->query('SELECT count(`iddata`) AS `nbData`, (SELECT count(`iditem`) FROM `' . TBL_I . '`) AS `nbItem`, (SELECT count(`idskill`) FROM `' . TBL_S . '`) AS `nbSkill`, (SELECT count(`idability`) FROM `' . TBL_AB . '`) AS `nbAbility` FROM `' . TBL_D . '`');
		if( $res->rowCount() == 1 ){
			$tmp     = $res->fetch();
			$stats['data'] = $tmp['nbData'];
			$stats['item'] = $tmp['nbItem'];
			$stats['skill'] = $tmp['nbSkill'];
			$stats['ability'] = $tmp['nbAbility'];
		}
		$res    = $db->query('SELECT `' . TBL_T . '`.`name`, count(`' . TBL_D . '`.`iddata`) AS `nb` FROM `' . TBL_T . '` LEFT JOIN `' . TBL_D . '` ON `' . TBL_D . '`.`idtype` = `' . TBL_T . '`.`idtype` GROUP BY `' . TBL_T . '`.`idtype`');
		$nbType = array();
		if( $res->rowCount() > 0 )
			$nbType = $res->fetchAll();
		$res      = $db->query('SELECT `' . TBL_CLA . '`.`name`, count(`' . TBL_D . '`.`iddata`) AS `nb` FROM `' . TBL_CLA . '` LEFT JOIN `' . TBL_D . '` ON `' . TBL_D . '`.`idclasse` = `' . TBL_CLA . '`.`idclasse` GROUP BY `' . TBL_CLA . '`.`idclasse`');
		$nbClasse = array();
		if( $res->rowCount() > 0 )
			$nbClasse = $res->fetchAll();
		$res   = $db->query('SELECT `iddata` FROM `' . TBL_D . '` ORDER BY `created` DESC LIMIT 10');
		$datas = array();
		if( $res->rowCount() > 0 )
			foreach($res as $r)
				$datas = new Data($r['iddata']);
		$page = 'home';
	}

	// Delete some variable from the page scope
	secureScope();

	include_once( $templates_path.$template.'/'.$page.'.php' );
}
catch( Exception $e ) {
	echo 'Exception : ' . $e->getMessage();
	try{
		$db = Database::getDatabase();
		$db->rollback();
	}catch(Exception $e){}
}

?>