<?php
/*
* @author Baptiste ROUSSEL
* @version 1.0.3
* @license MPL 2.0
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. 
* If a copy of the MPL was not distributed with this file, You can obtain one at http://mozilla.org/MPL/2.0/.
*/
session_start();
require_once( 'config.inc.php' );
$menu_url = array(
	"panel.php",
	array(
		"panel.php?p=sheet_search",
		"panel.php?p=add_sheet",
		null,
		"panel.php?p=ability",
		null,
		"panel.php?p=skill_search",
		"panel.php?p=add_skill",
		null,
		"panel.php?p=fields"
	),
	array(
		"panel.php?p=item_search",
		"panel.php?p=add_item",
		null,
		"panel.php?p=item_category"
	),
	"panel.php?p=type",
	"panel.php?p=classe",
	array(
		"panel.php?p=account",
		"panel.php?p=add_account",
		null,
		"panel.php?p=logs"
	),
	"index.php?cat=logoff"
);

if( empty($_SESSION['id']) ) {
	// Not loggued
	header('Location: index.php?login=0'); // Ask for a login
	exit();
}

try {

	$page     = 'admin';
	$category = '';
	if( !empty($_GET['p']) ){
			$category = $_GET['p'];
			switch($category){
				case 'sheet_search':
					// Form search for Data Sheet
					if( !isAllowed('sheet-read') )
						break;
					$datas = array();
					if( isSet($_POST['data_name']) ){
						$db = Database::getDatabase();
						if( !empty($_POST['data_name']) ){
							$res = $db->query('SELECT `iddata` FROM `' . TBL_D . '` WHERE `name` LIKE ' . $db->quote('%'.$_POST['data_name'].'%'));
						}else{
							$res = $db->query('SELECT `iddata` FROM `' . TBL_D . '`');
						}
						if( $res->rowCount() > 0 )
							foreach($res as $c)
								$datas = new Data($c['iddata']);
					}
					break;
				case 'sheet':
					if( !isAllowed('sheet-read') )
						break;
					if( !empty($_GET['id']) && is_numeric($_GET['id']) ){
						$data      = new Data($_GET['id'],Data::FULL);
						Type::loadAll();
						Classe::loadAll();
						Skill::loadAll();
						Item::loadAll();
						Ability::loadAll();
						$types = Type::getFirst();
						$classes = Classe::getFirst();
						$skills = Skill::getFirst();
						$items = Item::getFirst();
						$abilities = Ability::getFirst();
						if( $types === null )
							$types = array();
						if( $classes === null )
							$classes = array();
						if( $skills === null )
							$skills = array();
						if( $items === null )
							$items = array();
						if( $abilities === null )
							$abilities = array();
						$bigfields = array();
						$attributes = array();
						$db        = Database::getDatabase();
						$res       = $db->query('SELECT `idbigfield`, `name` FROM `' . TBL_BIG . '` ORDER BY `idbigfield`');
						if( $res->rowCount() > 0 )
							while($b = $res->fetch() )
								$bigfields[$b['idbigfield']] = $b['name'];
						$res       = $db->query('SELECT `idattribute`, `name` FROM `' . TBL_ATT . '` ORDER BY `idattribute`');
						if( $res->rowCount() > 0 )
							while($b = $res->fetch() )
								$attributes[$b['idattribute']] = $b['name'];
					}
					else{
						header('Location: panel.php?p=sheet_search');
						exit();
					}
					break;
				case 'add_sheet':
					if( !isAllowed('sheet-edit') ) // Did you ever see people who can add without edit ?
						break;
					$data         = new Data();
					$data->type   = new Type();
					$data->classe = new Classe();
					Type::loadAll();
					Classe::loadAll();
					Skill::loadAll();
					Item::loadAll();
					Ability::loadAll();
					$types = Type::getFirst();
					$classes = Classe::getFirst();
					$skills = Skill::getFirst();
					$items = Item::getFirst();
					$abilities = Ability::getFirst();
					if( $types === null )
						$types = array();
					if( $classes === null )
						$classes = array();
					if( $skills === null )
						$skills = array();
					if( $items === null )
						$items = array();
					if( $abilities === null )
						$abilities = array();
					$bigfields    = array();
					$attributes   = array();
					$db           = Database::getDatabase();
					$res          = $db->query('SELECT `idbigfield`, `name` FROM `' . TBL_BIG . '` ORDER BY `idbigfield`');
					if( $res->rowCount() > 0 )
						while($b = $res->fetch() )
							$bigfields[$b['idbigfield']] = $b['name'];
					$res          = $db->query('SELECT `idattribute`, `name` FROM `' . TBL_ATT . '` ORDER BY `idattribute`');
					if( $res->rowCount() > 0 )
						while($b = $res->fetch() )
							$attributes[$b['idattribute']] = $b['name'];
					break;
				case 'skill_search':
					// Form search for Skill
					if( !isAllowed('skill-read') )
						break;
					$skills = array();
					if( isSet($_POST['skill_name']) ){
						$db = Database::getDatabase();
						if( !empty($_POST['skill_name']) ){
							$res = $db->query('SELECT `idskill` FROM `' . TBL_S . '` WHERE `name` LIKE ' . $db->quote('%'.$_POST['skill_name'].'%'));
						}else{
							$res = $db->query('SELECT `idskill` FROM `' . TBL_S . '`');
						}
						if( $res->rowCount() > 0 )
							foreach($res as $c)
								$skills = new Skill($c['idskill']);
					}
					break;
				case 'skill':
					if( !isAllowed('skill-read') )
						break;
					if( !empty($_GET['id']) && is_numeric($_GET['id']) ){
						$skill = new Skill($_GET['id']);
					}
					else{
						header('Location: panel.php?p=skill_search');
						exit();
					}
				case 'add_skill':
					if( !isAllowed('skill-edit') ) // Did you ever see people who can add without edit ?
						break;
					// parse the CSS icon file
					$file  = file_get_contents($icon_path_file);
					preg_match_all('#div\.icon(.*) {#',$file,$lines);
					$icons = $lines[1];
				break;
				case 'fields':
					if( !isAllowed('fields-read') )
						break;
					$bigfields  = array();
					$tinyfields = array();
					$db         = Database::getDatabase();
					$res        = $db->query('SELECT `idbigfield`, `name` FROM `' . TBL_BIG . '` ORDER BY `idbigfield`');
					if( $res->rowCount() > 0 )
						while($b = $res->fetch() )
							$bigfields[$b['idbigfield']] = $b['name'];
					$res = $db->query('SELECT `idattribute`, `name`, `description` FROM `' . TBL_ATT . '` ORDER BY `idattribute`');
					if( $res->rowCount() > 0 )
						while($b = $res->fetch() )
							$tinyfields[$b['idattribute']] = $b;
					break;
				case 'item_search':
					if( !isAllowed('item-read') )
						break;
					// Form search for Item
					$items = array();
					if( isSet($_POST['item_name']) ){
						$db = Database::getDatabase();
						if( !empty($_POST['item_name']) ){
							$res = $db->query('SELECT `iditem` FROM `' . TBL_I . '` WHERE `name` LIKE ' . $db->quote('%'.$_POST['item_name'].'%'));
						}else{
							$res = $db->query('SELECT `iditem` FROM `' . TBL_I . '`');
						}
						if( $res->rowCount() > 0 )
							foreach($res as $c)
								$items = new Item($c['iditem']);
					}
					break;
				case 'item':
					if( !isAllowed('item-read') )
						break;
					if( !empty($_GET['id']) && is_numeric($_GET['id']) ){
						$item = new Item($_GET['id']);
					}
					else{
						header('Location: panel.php?p=item_search');
						exit();
					}
				case 'add_item':
					if( !isAllowed('item-edit') ) // Did you ever see people who can add without edit ?
						break;
					// get categories
					$db  = Database::getDatabase();
					$res = $db->query('SELECT `iditemcategory`, `name` FROM `' . TBL_I_CAT . '` ORDER BY `name`');
					$categories = array();
					if( $res->rowCount() > 0 )
						foreach($res as $c)
							$categories[$c['iditemcategory']] = $c['name'];
					// parse the CSS icon file
					$file  = file_get_contents($icon_path_file);
					preg_match_all('#div\.icon(.*) {#',$file,$lines);
					$icons = $lines[1];
					break;
				case 'item_category':
					if( !isAllowed('item_category-read') )
						break;
					$categories = array();
					$db         = Database::getDatabase();
					$res        = $db->query('SELECT `iditemcategory`, `name` FROM `' . TBL_I_CAT . '` ORDER BY `iditemcategory`');
					if( $res->rowCount() > 0 )
						while($b = $res->fetch() )
							$categories[$b['iditemcategory']] = $b['name'];
					break;
				case 'type':
					if( !isAllowed('type-read') )
						break;
					Type::loadAll();
					Ability::loadAll();
					$types = Type::getFirst();
					$abilities = Ability::getFirst();
					if( $types === null )
						$types = array();
					if( $abilities === null )
						$abilities = array();
					$type      = null;
					if( !empty($_GET['id']) ){
						$type = Type::getType($_GET['id']);
					}
					break;
				case 'classe':
					if( !isAllowed('classe-read') )
						break;
					Classe::loadAll();
					Ability::loadAll();
					$classes = Classe::getFirst();
					$abilities = Ability::getFirst();
					if( $classes === null )
						$classes = array();
					if( $abilities === null )
						$abilities = array();
					$classe    = null;
					if( !empty($_GET['id']) ){
						$classe = Classe::getClasse($_GET['id']);
					}
					break;
				case 'ability':
					if( !isAllowed('ability-read') )
						break;
					Ability::loadAll();
					$abilities = Ability::getFirst();
					if( $abilities === null )
						$abilities = array();
					$ability = null;
					if( !empty($_GET['id']) ){
						$ability = Ability::getAbility($_GET['id']);
					}
					break;
				case 'account':
					if( !isAllowed('account-read') )
						break;
					$db       = Database::getDatabase();
					$res      = $db->query('SELECT `idgm_account` AS `id`, `login` FROM `' . TBL_GM_ACT . '` ORDER BY `idgm_account`');
					$accounts = array();
					while($r = $res->fetch())
						$accounts[$r['id']] = $r;
					$res    = $db->query('SELECT `idgm_account` AS `id`, `' . TBL_ACC . '`.`idaccess`, `name` FROM `' . TBL_ACC . '` LEFT JOIN `' . TBL_GM_ACC . '` ON `' . TBL_ACC . '`.`idaccess` = `' . TBL_GM_ACC . '`.`idaccess` ORDER BY `' . TBL_GM_ACC . '`.`idgm_account`, `' . TBL_ACC . '`.`idaccess`');
					$access = array();
					while($r = $res->fetch())
						$access[$r['id']][$r['idaccess']] = $r;
					if( !empty($_GET['id']) && is_numeric($_GET['id']) && isSet($accounts[$_GET['id']]) ){
						$gm          = array();
						$gm['id']    = $_GET['id'];
						$gm['login'] = $accounts[$gm['id']]['login'];
					}
					break;
				case 'add_account':
					if( !isAllowed('account-add') )
						break;
					$db     = Database::getDatabase();
					$res    = $db->query('SELECT `' . TBL_ACC . '`.`idaccess`, `name` FROM `' . TBL_ACC . '` ORDER BY `' . TBL_ACC . '`.`idaccess`');
					$access = array();
					$gm     = array('id' => 0, 'login' => '');
					while($r = $res->fetch())
						$access[0][$r['idaccess']] = $r;
					break;
				case 'logs':
					$db      = Database::getDatabase();
					$res     = $db->query('SELECT `' . TBL_GM_ACT . '`.`login`, `' . TBL_GM_LOG . '`.`value`, `' . TBL_GM_LOG . '`.`created` FROM `' . TBL_GM_LOG . '` LEFT JOIN `' . TBL_GM_ACT . '` ON `' . TBL_GM_ACT . '`.`idgm_account` = `' . TBL_GM_LOG . '`.`idgm_account` ORDER BY `' . TBL_GM_LOG . '`.`created` DESC');
					$gm_logs = $res->fetchAll();
					break;
				default:
					$p_error = true;
					break;
			}
	}
	if( empty($_GET['p']) || isSet($p_error)){
		// Index of GM Panel
		$db    = Database::getDatabase();
		$res   = $db->query('SELECT `iddata` FROM `' . TBL_D . '` ORDER BY `modified` DESC LIMIT 10');
		$datas = array();
		if( $res->rowCount() > 0 )
			foreach($res as $r)
				$datas = new Data($r['iddata']);
		$res     = $db->query('SELECT `' . TBL_GM_ACT . '`.`login`, `' . TBL_GM_LOG . '`.`value`, `' . TBL_GM_LOG . '`.`created` FROM `' . TBL_GM_LOG . '` LEFT JOIN `' . TBL_GM_ACT . '` ON `' . TBL_GM_ACT . '`.`idgm_account` = `' . TBL_GM_LOG . '`.`idgm_account` ORDER BY `' . TBL_GM_LOG . '`.`created` DESC LIMIT 10');
		$gm_logs = $res->fetchAll();
	}

	// Delete some variable from the page scope
	secureScope();

	include_once( 'templates/admin/'.$page.'.php' );
}
catch( Exception $e ) {
	//echo $e;
	try{
		$db = Database::getDatabase();
		$db->rollback();
	}catch(Exception $e){}
}
?>