/*
* Roll a dice for an ability and perform a check of the total value
* @param (String) Dice : 1D6 => NumberOfDice D NumberOfFace
* @param (String) field : [type, classe]
* @param (int) id
*@return (bool)
*/
function dice(d, field, id){
	if( d === null || d.length == 0 )
		return false;
	var dice = d.split(new RegExp("[D]","g"));
	if(dice.length == 1 && dice[0] == '-')
		return false;
	// roll the dice
	var result = 0;
	for(i=0; i<dice[0]; i++)
		result += Math.floor(Math.random() * dice[1]) + 1;
	// update the result
	$('.ab_' + field + '_' + id).val(result);
	var fontsize = $('.ab_' + field + '_' + id).css('font-size');
	$('.ab_' + field + '_' + id).animate({
		fontSize: '24px'
  	}, 500, function() {
    	$('.ab_' + field + '_' + id).animate({
			fontSize: fontsize,
  		}, 500, null);
  	});
  	return validateAbilityAndUpdate(id);
}

/*
* Check the total value of an ability
* @param (int) id
* @return (bool)
*/
function validateAbilityAndUpdate(id){
	var min = $('.ab_min_' + id).val();
	var max = $('.ab_max_' + id).val();
	var type = $('.ab_type_' + id).val();
	var type_bonus = $('.ab_type_bonus_' + id).html();
	var classe = $('.ab_classe_' + id).val();
	var classe_bonus = $('.ab_classe_bonus_' + id).html();
	var bonus = $('.ab_bonus_' + id).val();
	if( min.length == 0 || max.length == 0 || type.length == 0 || type_bonus.length == 0 || classe.length == 0 || classe_bonus.length == 0 || bonus.length == 0 )
		return false;
	var value = parseInt(type) + parseInt(type_bonus) + parseInt(classe) + parseInt(classe_bonus) + parseInt(bonus);
	$('.ab_' + id).html(value);
	if( value >= min && value <= max ){
		$('.ab_' + id).removeClass('red');
		return true;
	}else{
		$('.ab_' + id).addClass('red');
		return false;
	}
}